// Ticker Trail.mq4
// 

#property copyright "mandorr@gmail.com"
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Blue
#property indicator_width1 1
#property indicator_width2 2
#property indicator_style1 0
#property indicator_style2 0
#property indicator_level1 0
#property indicator_levelcolor Silver
#property indicator_levelwidth 1
#property indicator_levelstyle STYLE_SOLID

extern int Trail=110;         // 
extern int TicksCount=1000;  //   

double buffer0[];
double buffer1[];

int ticks[];
int trails[];

int trail;
int ticks_count;
int bid_prev;

void init() {
   SetIndexBuffer(0,buffer0);
   SetIndexBuffer(1,buffer1);
   SetIndexLabel(0,"Value");
   SetIndexLabel(1,"Trail");
   SetIndexDrawBegin(0,0);
   SetIndexDrawBegin(1,0);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   IndicatorDigits(Digits);
   bid_prev=0;
   trail=MathMax(Trail,1);
   ticks_count=MathMax(TicksCount,10);
   IndicatorShortName("Ticker Trail ("+trail+")");
   ArrayResize(ticks,ticks_count);
   ArrayResize(trails,ticks_count);
}

void deinit() {
}

void start() {
   if (bid_prev==0) {Setup();}
   SetIndicator();
}

//   
//     OHL  
void Setup() {
   int i, j, k, bid, total, value[4];
   double open, high, low, median;
   //  
   for (i=0; i<=ticks_count; i++) {
      ticks  [i]=0;
      trails [i]=0;
      buffer0[i]=0.0;
      buffer1[i]=0.0;
   }
   //  
   total=ticks_count; if (total>iBars(NULL,PERIOD_M1)) {total=iBars(NULL,PERIOD_M1);}
   open=iOpen(NULL,PERIOD_M1,total-1);
   bid=MathRound(open/Point);
   ticks [0]=bid;
   trails[0]=bid;
   bid_prev=0;
   //     OHL  
   for (i=total-1; i>=0; i--) {
      open=iOpen(NULL,PERIOD_M1,i);
      high=iHigh(NULL,PERIOD_M1,i);
      low =iLow (NULL,PERIOD_M1,i);
      median=0.5*(high+low);
      value[0]=MathRound(open/Point);
      value[1]=MathRound(high/Point);
      value[2]=MathRound(low /Point);
      value[3]=0;
      if (open<median) {
         //    OHL  OLH
         value[3]=value[1];
         value[1]=value[2];
         value[2]=value[3];
      }
      for (j=0; j<=2; j++) {
         bid=value[j];
         if (bid==bid_prev) {continue;}
         bid_prev=bid;
         for (k=ticks_count-1; k>0; k--) {
            ticks [k]=ticks [k-1];
            trails[k]=trails[k-1];
         }
         ticks[0]=bid;
         if (trails[0]<bid-trail) {trails[0]=bid-trail;}
         if (trails[0]>bid+trail) {trails[0]=bid+trail;}
      }
   }
   for (i=0; i<ticks_count; i++) {
      buffer0[i]=ticks [i]*Point;
      buffer1[i]=trails[i]*Point;
   }
   buffer0[ticks_count]=0.0;
   buffer1[ticks_count]=0.0;
   SetLevelValue(0,bid*Point);
   RefreshRates();
}

void SetIndicator() {
   int i, bid;
   bid=MathRound(Bid/Point);
   if (bid==0) {return;}
   if (bid==bid_prev) {return;}
   bid_prev=bid;
   for (i=ticks_count-1; i>0; i--) {
      ticks [i]=ticks [i-1];
      trails[i]=trails[i-1];
   }
   ticks[0]=bid;
   if (trails[0]<bid-trail) {trails[0]=bid-trail;}
   if (trails[0]>bid+trail) {trails[0]=bid+trail;}
   for (i=0; i<ticks_count; i++) {
      buffer0[i]=ticks [i]*Point;
      buffer1[i]=trails[i]*Point;
   }
   buffer0[ticks_count]=0.0;
   buffer1[ticks_count]=0.0;
   SetLevelValue(0,bid*Point);
}

// End